#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <sstream>
#include <cstring>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;

struct resstruct {
	int xg1, yg1, xg2, yg2, pos, type;
};

#define NORTH 1
#define EAST 2
#define SOUTH 3
#define WEST 4
int moves[][2] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};
char karta[101][101];
int r, c, g, k, n;
int rmilkb, cmilkb, rmilke, cmilke;
map <int, pair <int, int> > teleports;
map <int, int> teleportsint;
map <pair <int, int>, pair <int, int> > teleportspair;
vector <resstruct> result;

bool inlightmatter(int i, int j)
{
	char c = karta[i][j];
	bool res = true;
	res &= (c == '-' || c == 't' || c =='b'||c=='s'||c=='p'||c=='h'||(c <='9'&&c>='1'));
	return res;
}
bool indarkmatter(int i, int j)
{
	return !inlightmatter(i, j); 
}
bool isship(int i, int j) { return karta[i][j] == 'h' || karta[i][j] == 'H'; }
bool inmilk(int i, int j) {
	return (i >= rmilkb && i <= rmilke && j >= cmilkb && j <= cmilke); }
bool valid(int i, int j) {
	char c = karta[i][j];
	if (c == 'p' || c == 'P' || c == 'b' || c == 'B' || c == 's' || c == 'S' ||
		c == 'h' || c == 'H') return false;
	return true;
}
bool easyvalid(int i, int j)
{
	char c = karta[i][j];
	if (c == 'p' || c == 'P' || c == 'b' || c == 'B' || c == 's' || c == 'S' ||
		c == 'h' || c == 'H') return false;
	if (karta[i+1][j] == 'b' || karta[i+1][j] == 'B') return false;
	if (karta[i-1][j] == 'b' || karta[i-1][j] == 'B') return false;
	if (karta[i][j+1] == 'b' || karta[i][j+1] == 'B') return false;
	if (karta[i][j-1] == 'b' || karta[i][j-1] == 'B') return false;
	return true;
}
void read()
{
	k = 0;
	n = 0;
	scanf("%d %d %d\n", &r, &c, &g);
	for (int i = 0; i < r; ++i)
	{
		for (int j = 0; j < c; ++j)
		{
			scanf("%c", &karta[i][j]);
			if (karta[i][j] == 't' || karta[i][j] == 'T') k++;
			if (karta[i][j] == 'h' || karta[i][j] == 'H') n++;
		}
		scanf("\n");
	}
	scanf("%d %d %d %d", &rmilkb, &cmilkb, &rmilke, &cmilke);
	for (int i = 0; i < k/2; ++i)
	{
		int x1, x2, y1, y2;
		scanf("%d %d %d %d", &x1, &y1, &x2, &y2);
		pii fst = make_pair(x1, y1);
		teleports[i] = fst;
		pii snd = make_pair(x2, y2);
		teleports[k/2 + i] = snd;
		teleportsint[i] = k/2 + i;
		teleportspair[fst] = snd;
		teleportspair[snd] = fst;
	}
}

bool nearbh(int i, int j)
{
	if (karta[i+1][j] == 'b' || karta[i+1][j] == 'B') return 1;
	if (karta[i-1][j] == 'b' || karta[i-1][j] == 'B') return 1;
	if (karta[i][j+1] == 'b' || karta[i][j+1] == 'B') return 1;
	if (karta[i][j-1] == 'b' || karta[i][j-1] == 'B') return 1;
	return 0;
}

vector <int> easywaymoves;
pii parts[100][100];
bool easyway(int i, int j)
{
	int seen[100][100];
	memset(seen, 0, sizeof(seen));
	seen[i][j] = 1;
	easywaymoves.clear();
	if (nearbh(i, j))
		return false;
	queue <pii > q;
	q.push(make_pair(i, j));
	while (!q.empty())
	{
		pii tmp = q.front();
		q.pop();
		for (int mv = 0; mv < 4; ++mv)
		{
			int x = tmp.first + moves[mv][0];
			int y = tmp.second + moves[mv][1];
			if (!seen[x][y] && inmilk(x, y) && easyvalid(x, y) && inlightmatter(x, y))
			{
				seen[x][y] = 1;
				parts[x][y] = tmp;
				do
					{
						pii prev = parts[x][y];
						if (prev.first < x) easywaymoves.push_back(SOUTH);
						if (prev.first > x) easywaymoves.push_back(NORTH);
						if (prev.second < y) easywaymoves.push_back(EAST);
						if (prev.second > y) easywaymoves.push_back(WEST);
						x = prev.first; y = prev.second;
					} while (!(x == i && y == j));
					reverse(easywaymoves.begin(), easywaymoves.end());
					return true;
			} else
			if (!seen[x][y] && easyvalid(x, y) && inlightmatter(x, y))
			{
				q.push(make_pair(x, y));
				seen[x][y] = 1;
				parts[x][y] = tmp;
				if (inmilk(x, y))
				{
					do
					{
						pii prev = parts[x][y];
						if (prev.first < x) easywaymoves.push_back(SOUTH);
						if (prev.first > x) easywaymoves.push_back(NORTH);
						if (prev.second < y) easywaymoves.push_back(EAST);
						if (prev.second > y) easywaymoves.push_back(WEST);
						x = prev.first; y = prev.second;
					} while (!(x == i && y == j));
					reverse(easywaymoves.begin(), easywaymoves.end());
					return true;
				}
			}
		}
	}
	return false;
}

void solve()
{
	for (int i = 0; i < r; ++i)
	{
		for (int j = 0; j < c; ++j)
		{
			if (isship(i, j))
			{
				if (inlightmatter(i, j) && easyway(i, j))
				{
					int x = i, y = j;
					for (int k = 0; k < easywaymoves.size(); ++k)
					{
						//printf("%d %d %d %d %d 1\n", x, y, x, y, easywaymoves[k]);
						resstruct mov;
						mov.xg1 = x, mov.xg2 = x, mov.yg1 = y, mov.yg2 = y, 
							mov.pos = easywaymoves[k], mov.type =1;
						result.push_back(mov);
						if (easywaymoves[k] == NORTH) x--;
						if (easywaymoves[k] == SOUTH) x++;
						if (easywaymoves[k] == EAST) y++;
						if (easywaymoves[k] == WEST) y--;
					}
					karta[i][j] = '-';
					karta[x][y] = 'h';
				} else 
				{
				//	if (findpath(i, j))
					{

					}
				}
			}
		}
	}
}

void write()
{
	int rez = result.size();
	printf("%d\n", rez);
	for (int i = 0; i < rez; ++i)
	{
		printf("%d %d %d %d %d %d\n", result[i].xg1, result[i].yg1, result[i].xg2, result[i].yg2,
			result[i].pos, result[i].type);
	}
}

int main()
{
	freopen("cosmos.in", "r", stdin);
	freopen("cosmos.out", "w", stdout);
	read();
	solve();
	
	write();
	return 0;
}